﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Reflection;
////写入注册表时要用到
using Microsoft.Win32;

namespace HideTaskbar
{
    public partial class Form1 : Form
    {
        KeyboardHook k_hook;
        bool isHide = false;
        public Form1()
        {
            InitializeComponent();
            k_hook = new KeyboardHook();
            k_hook.KeyDownEvent += new KeyEventHandler(hook_KeyDown);//钩住键按下
            k_hook.Start();//安装键盘钩子
        }
        private const int SW_HIDE = 0;  //隐藏任务栏
        private const int SW_RESTORE = 9;//显示任务栏
        [DllImport("user32.dll")]
        //.API函数ShowWindow()能够控制人和窗体的现实状态，
        public static extern int ShowWindow(int hwnd, int nCmdShow);

        [DllImport("user32.dll")]
        //.API函数FindWindow()可用于返回任务栏所在窗体类“Shell_TrayWnd”句柄，
        public static extern int FindWindow(string lpClassName, string lpWindowName);

        //判断输入键值（实现KeyDown事件）
        private void hook_KeyDown(object sender, KeyEventArgs e)
        {
            //判断按下的键（Alt + Q）
            if (e.KeyValue == (int)Keys.Q && (int)Control.ModifierKeys == (int)Keys.Alt)
            {
               
                if (!isHide)
                {
                    //ShowWindow(FindWindow("Shell_TrayWnd", null), SW_HIDE);
                    //隐藏任务栏
                    ShowWindow(FindWindow("Shell_TrayWnd", null), SW_HIDE);
                    timer1.Start();
                }
                else
                {
                    timer1.Stop();
                    //显示任务栏
                    ShowWindow(FindWindow("Shell_TrayWnd", null), SW_RESTORE);
                }
                isHide = !isHide;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //隐藏程序 使其不出现在任务栏 也不出现在系统托盘
            this.Hide();
            this.ShowInTaskbar = false;
        }
        //系统托盘中程序图标有变化，任务栏会显示
        //设置一个时间器
        private void Timer1_Tick(object sender, EventArgs e)
        {
            ShowWindow(FindWindow("Shell_TrayWnd", null), SW_HIDE);
        }
    }
}
